<?php
/*
+---------------------------------------------------------------+
|        Unanswered Forum Posts Menu for e107 v7xx - by Father Barry
|
|        This module for the e107 .7+ website system
|        Copyright Barry Keal 2004-2009
|
|        Released under the terms and conditions of the
|        GNU General Public License (http://gnu.org).
|
+---------------------------------------------------------------+
*/

require_once('../../class2.php');

if (!defined('e107_INIT'))
{
    exit;
}
// global $sql, $tp, $unanswered_obj, $unanswer_shortcodes, $unanswer_link, $unanswer_date, $unanswer_bullet, $unanswer_head;
if (!is_object($unanswered_obj))
{
    require_once(e_PLUGIN . 'unanswered/includes/unanswered_class.php');
    $unanswered_obj = new unanswered;
}
$cache_tag = "unanswered";
// only cache if posts aging over 0 days, otherwise it won't show up today's unanswered posts
// Force retrieval to 1440
$cacheData = $e107cache->retrieve($cache_tag, 1440);
if ($unanswered_obj->unanswer_overdays > 0 && !empty($cacheData))
{
    echo $cacheData;
    return;
}

include_lan(e_PLUGIN . "unanswered/languages/" . e_LANGUAGE . "_unanswered.php");

require_once(e_HANDLER . "date_handler.php");
if (is_readable(THEME . "unanswered_template.php"))
{
    require(THEME . "unanswered_template.php");
}
else
{
    require(e_PLUGIN . "unanswered/templates/unanswered_template.php");
}
if (file_exists(THEME . "forum/new_small.png"))
{
    $ICON = "<img src='" . THEME . "forum/new_small.png' alt='' />";
}
else
{
    $ICON = "<img src='" . e_PLUGIN_ABS . "forum/images/" . IMODE . "/new_small.png' alt='' />";
}
if (e_QUERY)
{
    $unanswer_from = e_QUERY;
}
else
{
    $unanswer_from = 0;
}
require_once(e_PLUGIN . "unanswered/includes/unanswered_shortcodes.php");
$unansfer_conv = new convert;
$unanswer_now = time() - (86400 * $unanswered_obj->unanswer_overdays);

$unanswer_limit = $unanswered_obj->unanswer_limit > 0?"limit 0," . $unanswered_obj->unanswer_num:"";
$unanswer_notbefore = $unanswered_obj->unanswer_notbefore > 0?"and thread_datestamp < " . $unanswer_now:"";

if ($unanswered_obj->unanswer_active == 1)
{
    $unanswer_active = " and thread_active=1 ";
    $unanswer_viewing .= UNANSWERED_I08;
}
else
{
    $unanswer_active = '';
}
if ($unanswered_obj->unanswer_order == 1)
{
    $unanswer_order = ' order by thread_datestamp desc ';
}
else
{
    $unanswer_order = ' order by thread_datestamp asc ';
}
// *
// *
// *
$unanswer_ignore = "";
if ($unanswered_obj->unanswer_sticky == 1 && $unanswered_obj->unanswer_announce == 1)
{
    // if ignore sticky and announcements then thread_s =0
    $unanswer_ignore = " and thread_s = 0 ";
    if (empty($unanswer_viewing))
    {
        $unanswer_viewing .= UNANSWERED_I09;
    }
    else
    {
        $unanswer_viewing .= ', ' . UNANSWERED_I09;
    }
}
if ($unanswered_obj->unanswer_sticky == 1 && $unanswered_obj->unanswer_announce == 0)
{
    // if ignore sticky only then thread_s <> 1
    $unanswer_ignore = " and thread_s <>1 ";
       if (empty($unanswer_viewing))
    {
        $unanswer_viewing .= UNANSWERED_I10;
    }
    else
    {
        $unanswer_viewing .= ', ' . UNANSWERED_I10;
    }
} elseif ($unanswered_obj->unanswer_sticky == 0 && $unanswered_obj->unanswer_announce == 1)
{
    // if ignore announcements only then threads_<>2
    $unanswer_ignore = " and thread_s <>2 ";
      if (empty($unanswer_viewing))
    {
        $unanswer_viewing .= UNANSWERED_I11;
    }
    else
    {
        $unanswer_viewing .= ', ' . UNANSWERED_I11;
    }
}
$unanswer_sql = "
select count(thread_id) as unanswer_total from #forum_t
left join #forum on thread_forum_id=forum_id
where thread_total_replies=0 and thread_parent=0 $unanswer_notbefore $unanswer_active $unanswer_ignore and find_in_set(forum_class,'" . USERCLASS_LIST . "')";
$sql->db_Select_gen($unanswer_sql, false);
extract($sql->db_Fetch());

$unanswer_sql = "
select thread_id,thread_name,thread_datestamp,thread_views,forum_name,forum_id,thread_user,user_lastvisit from #forum_t
left join #forum on thread_forum_id=forum_id
left join #user  ON SUBSTRING_INDEX(thread_user,'.',1) = user_id
where thread_total_replies=0 and thread_parent=0 $unanswer_notbefore $unanswer_active $unanswer_ignore and find_in_set(forum_class,'" . USERCLASS_LIST . "')
$unanswer_order limit $unanswer_from,20";
if ($sql->db_Select_gen($unanswer_sql, false))
{
    $unanswer_head = UNANSWER_002;
    $unanswer_bullet = "<img src='" . e_PLUGIN . "unanswered/images/unanswered_10.png' alt='' />";
    while ($unanswer_row = $sql->db_Fetch())
    {
        extract($unanswer_row);

        $unanswer_new = (USERLV < $thread_datestamp?$ICON:'&nbsp;');
        $unanswer_tmp = explode('.', $thread_user, 2);
        $unanswer_forum = '<a href="' . e_PLUGIN . 'forum/forum_viewforum.php?' . $forum_id . '">' . $tp->toHTML($forum_name, false) . '</a>';
        $unanswer_poster = '<a href="' . e_BASE . 'user.php?' . $unanswer_tmp[0] . '">' . $tp->toHTML($unanswer_tmp[1], false) . '</a>';
        $unanswer_views = $thread_views;
        if ($unanswered_obj->unanswer_date > 0)
        {
            $unanswer_date = $unansfer_conv->convert_date($thread_datestamp, "forum");
        }
        $unanswer_link = "<a href='" . e_PLUGIN . "forum/forum_viewtopic.php?$thread_id' >" . $tp->html_truncate($thread_name, $unanswered_obj->unanswer_maxlen, $unanswered_obj->unanswer_more) . "</a>";
        $unanswer_details .= $tp->parseTemplate($UNANSWER_LIST_DETAIL, false, $unanswer_shortcodes);
    } // while
}
else
{
    $unanswer_head = UNANSWER_003;
}
// Now create the menu from the template
$unanswer_parms = $unanswer_total . ",20," . $unanswer_from . "," . e_SELF . '?' . "[FROM]." ;

$unanswer_nextprev = $tp->parseTemplate("{NEXTPREV={$unanswer_parms}}") . "";
$unanswer_text = $tp->parseTemplate($UNANSWER_LIST_HEADER, false, $unanswer_shortcodes);
$unanswer_text .= $unanswer_details;

$unanswer_text .= $tp->parseTemplate($UNANSWER_LIST_FOOTER, false, $unanswer_shortcodes);
// Set up a new output buffer and render the menu
ob_start();
require_once(HEADERF);
$ns->tablerender(UNANSWER_001, $unanswer_text, 'unansweredpage'); // Render the menu
require_once(FOOTERF);
$cache_data = ob_get_flush(); // Get the menu content, and display it
$e107cache->set($cache_tag, $cache_data); // Save to cache
